//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                                        MaByMa.mq4|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1

extern string TimeFrame = "Current time frame";  
extern int ma      = 25;
extern int signal  = 5;
extern int maType  = 3;
extern int maPrice = 0;
extern double arrowGap = 0.75;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";
extern bool   ArrowOnFirstBar = true;

double SignalBuffer1[];
double SignalBuffer2[];
double arrowUp[];
double arrowDn[];
double trend[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;



int init(){
   IndicatorDigits(Digits + 1);
   IndicatorBuffers(5);
   SetIndexBuffer(0, SignalBuffer1);
   SetIndexBuffer(1, SignalBuffer2);
   SetIndexBuffer(2, arrowUp); SetIndexStyle(2, DRAW_ARROW); SetIndexArrow(2,241);
   SetIndexBuffer(3, arrowDn); SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3,242);
   SetIndexBuffer(4, trend);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName(timeFrameToString(timeFrame)+" MaByMa(" + ma + "," + signal + ")");
   SetIndexLabel(0, "SignalBuffer1");
   SetIndexLabel(1, "SignalBuffer2");
return(0);
}



int start(){
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { SignalBuffer1[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (ArrowOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);   
                  int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                     SignalBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma,signal,maType,maPrice,arrowGap,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
                     SignalBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma,signal,maType,maPrice,arrowGap,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
                  if (x!=y)
                  {
                     arrowUp[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma,signal,maType,maPrice,arrowGap,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
                     arrowDn[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma,signal,maType,maPrice,arrowGap,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
                  }
               }
               return(0);
            }

   for(i = limit; i >= 0; i--) {
      SignalBuffer1[i] = iMA(NULL, 0, ma, 0, maType, maPrice, i);
      //SignalBuffer2[i] = indicators.getMaByMaValue(ma, signal, Period(), i);
   } 
   
   for(i = limit; i >= 0; i--) {
      SignalBuffer2[i] = iMAOnArray(SignalBuffer1, 0, signal, 0, maType, i);
      arrowUp[i] = EMPTY_VALUE;
      arrowDn[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
         if (SignalBuffer1[i] > SignalBuffer2[i]) trend[i] =  1;
         if (SignalBuffer1[i] < SignalBuffer2[i]) trend[i] = -1;
         if (trend[i]!=trend[i+1])
            if (trend[i] == 1) 
                  arrowUp[i] = MathMin(SignalBuffer1[i],SignalBuffer2[i]) -iATR(NULL,0,20,i)*arrowGap;
            else  arrowDn[i] = MathMax(SignalBuffer1[i],SignalBuffer2[i])+iATR(NULL,0,20,i*arrowGap);
            }
            
            if (alertsOn)
            {
            if (alertsOnCurrent)
                 int whichBar = 0;
            else     whichBar = 1;

            //
            //
            //
            //
            //
          
            if (trend[whichBar] != trend[whichBar+1])
            if (trend[whichBar] == 1)
                  doAlert("uptrend");
            else  doAlert("downtrend");       
   }
return(0);
}  

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MaByMa ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MaByMa "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
} 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

